<?php
session_start();

$config = dirname(__FILE__) . '/hybridauth/config.php';
require_once( "./hybridauth/Hybrid/Auth.php" );

/*

http://hybridauth.sourceforge.net/



ตัวอย่านี้ผมสร้างไฟล์ 2 ไฟล์
1. index.php เพื่อใช้ในการ ล็อกอิน , และดึงข้อมูล
2. share.php เพื่อส่งข้อมูลผ่าน API ไปยัง provider กรณีที่ login ด้วย Facebook หรือ Provider อนุญาติให้ส่งข้อความเขาไปได้
   ซึ่งการ Post ข้อมูลไปทำได้ง่ายมาก ดังตัวอย่าง

เริ่มต้นก็ต้องไปสมัคร Dev ของ facebook, google, etc... สิ่งที่สำคัญ ในการสมัคร
1. Redirect URIs: http://localhost/hybrid-test/hybridauth/?hauth.done=Google    // URL ที่ Callback จาก prvider
2. App ID , Secret Key
3. Host name or Server name


การ Config ใน config.php
1. "base_url" => "http://localhost/hybrid-test/hybridauth/" ชี้ไปยัง URL หลัก ของ Lib
2. ใส่ App ID , Secret Key ใน providers ที่เราได้ Key มา
3. ตัวไหนไม่ใช้ให้เป็น "enabled" => false อันนี้ไม่จำเป็น

ตัวอย่างทั้งหมดอยุ่ที่ :
http://hybridauth.sourceforge.net/userguide.html
http://hybridauth.sourceforge.net/apidoc.html

 */



if (isset($_REQUEST['action'])) {
    if ($_REQUEST['action'] == 'logout') {
        session_destroy();
        header("Location: ./");
    } else {
        $_SESSION['provider'] = $_REQUEST['action'];    // เก็บว่าเรา login ด้วยบัญชีไหน
        $hybridauth = new Hybrid_Auth($config);
        try {
            $adapter = $hybridauth->authenticate(trim($_SESSION['provider']));
            $user_data = $adapter->getUserProfile();
            $_SESSION['user_name'] = $user_data->displayName;
            //---> เก็บข้อมุลหรือนำปตรวจสอบว่ามีอยู่แล้ว 
            //---> $user_data ข้อมูลทั้งหมดที่ Provider ให้มา
            ?>
            <a href="<?php echo $user_data->profileURL; ?>"><img src="<?php echo $user_data->photoURL; ?>" border="1"></a>
            <table width="100%" cellspacing="0" cellpadding="3" border="0">
                <tbody>
                    <tr>
                        <td width="10%">providerID</td>
                        <td width="83%">&nbsp; <?php echo $adapter->id; ?></td>
                    </tr>
                    <tr>
                        <td width="10%">identifier</td>
                        <td width="83%">&nbsp; <?php echo $user_data->identifier; ?></td>
                    </tr> 
                    <tr>
                        <td>profileURL</td>
                        <td>&nbsp; <a href="<?php echo $user_data->profileURL; ?>"><?php echo $user_data->profileURL; ?></a></td>
                    </tr>
                    <tr>
                        <td>webSiteURL</td>
                        <td>&nbsp; <?php echo $user_data->webSiteURL; ?></td>
                    </tr>
                    <tr>
                        <td>photoURL</td>
                        <td>&nbsp; <?php echo $user_data->photoURL; ?></td>
                    </tr>
                    <tr>
                        <td>displayName</td>
                        <td>&nbsp; <?php echo $user_data->displayName; ?></td>
                    </tr>
                    <tr>
                        <td>description</td>
                        <td>&nbsp; <?php echo $user_data->description; ?></td>
                    </tr>
                    <tr>
                        <td>firstName</td>
                        <td>&nbsp; <?php echo $user_data->firstName; ?></td>
                    </tr>
                    <tr>
                        <td>lastName</td>
                        <td>&nbsp; <?php echo $user_data->lastName; ?></td>
                    </tr>
                    <tr>
                        <td>gender</td>
                        <td>&nbsp; <?php echo $user_data->gender; ?></td>
                    </tr>
                    <tr>
                        <td>language</td>
                        <td>&nbsp; <?php echo $user_data->language; ?></td>
                    </tr>
                    <tr>
                        <td>age</td>
                        <td>&nbsp; <?php echo $user_data->age; ?></td>
                    </tr>
                    <tr>
                        <td>birthDay</td>
                        <td>&nbsp; <?php echo $user_data->birthDay; ?></td>
                    </tr>
                    <tr>
                        <td>birthMonth</td>
                        <td>&nbsp; <?php echo $user_data->birthMonth; ?></td>
                    </tr>
                    <tr>
                        <td>birthYear</td>
                        <td>&nbsp; <?php echo $user_data->birthYear; ?></td>
                    </tr>
                    <tr>
                        <td>email</td>
                        <td>&nbsp; <?php echo $user_data->email; ?></td>
                    </tr>
                    <tr>
                        <td>phone</td>
                        <td>&nbsp; <?php echo $user_data->phone; ?></td>
                    </tr>
                    <tr>
                        <td>address</td>
                        <td>&nbsp; <?php echo $user_data->address; ?></td>
                    </tr>
                    <tr>
                        <td>country</td>
                        <td>&nbsp; <?php echo $user_data->country; ?></td>
                    </tr>
                    <tr>
                        <td>region</td>
                        <td>&nbsp; <?php echo $user_data->region; ?></td>
                    </tr>
                    <tr>
                        <td>city</td>
                        <td>&nbsp; <?php echo $user_data->city; ?></td>
                    </tr>
                    <tr>
                        <td>zip</td>
                        <td>&nbsp; <?php echo $user_data->zip; ?></td>
                    </tr>
                </tbody>
            </table>
            <?php
        } catch (Exception $e) {
            switch ($e->getCode()) {
                case 0 : $error = "Unspecified error.";
                    break;
                case 1 : $error = "Hybriauth configuration error.";
                    break;
                case 2 : $error = "Provider not properly configured.";
                    break;
                case 3 : $error = "Unknown or disabled provider.";
                    break;
                case 4 : $error = "Missing provider application credentials.";
                    break;
                case 5 : $error = "Authentification failed. The user has canceled the authentication or the provider refused the connection.";
                    break;
                case 6 : $error = "User profile request failed. Most likely the user is not connected to the provider and he should to authenticate again.";
                    $adapter->logout();
                    break;
                case 7 : $error = "User not connected to the provider.";
                    $adapter->logout();
                    break;
            }
            $error .= "<br /><br /><b>Original error message:</b> " . $e->getMessage();
            $error .= "<hr /><pre>Trace:<br />" . $e->getTraceAsString() . "</pre>";
            echo $error;
        }
    }
    
}

if (isset($_SESSION['user_name']) && $_SESSION['user_name'] != NULL) {
    echo 'Hello : ', $_SESSION['user_name'], ' login with ', $_SESSION['provider'];
    echo '<hr/><a href="./share.php">Share</a> | <a href="./?action=logout">Logout</a>';
} else {
    echo '<a href="./?action=Google">Google login</a>';
}
?>
